# -*- coding: utf-8 -*-
"""
Created on Mon Nov 6
Modified on Nov 22

@author: johana
Selection ,rotation, and mutual information
"""

from PIL import Image
import numpy as np
import math

SCALE=2.0
MAP=21.74/SCALE
MAPS=15.712/SCALE
TIX=6000/SCALE
TIY=4000/SCALE
DSIZE=256

# Coordinate calibration
CALX=550
CALY=250

DXIR30=-CALX+6078*1/MAP
DYIR30=-CALY+3342*1/MAP

DXIR31=-CALX+4722*1/MAPS
DYIR31=-CALY+2596*1/MAPS

DXUV30=-CALX+5976*1/MAP
DYUV30=-CALY+3292*1/MAP

DXUV31=-CALX+6204*1/MAP
DYUV31=-CALY+3394*1/MAP

DXSV30=-CALX+6216*1/MAP
DYSV30=-CALY+3400*1/MAP

DXSV31=-CALX+6165*1/MAP
DYSV31=-CALY+3360*1/MAP

PASOS=360/7
ABSV=2*PASOS
ABUV=-2*PASOS
ABIR=3*PASOS
ABTR=-3*PASOS

CAM_ANGLE=30
PUN_ANGLE=90
PASOM = 10


def capcam(imagen,cor,angle,case=0,other=0):
    dbox = TIX*2
    dboy = TIY*2
    if other == 0:
        center = np.array([[cor[0]*MAP],[cor[1]*MAP]])
    else:
        center = np.array([[cor[0]*MAPS],[cor[1]*MAPS]])
    box = (int(center[0]-dbox/2), int(center[1]-dbox/2), int(center[0]+dbox/2), int(center[1]+dbox/2))
    region = imagen.crop(box)
    #region.save("ROI.jpg")

    # Rotate
    girada = region.rotate(angle)
    center=np.array([[dbox/2],[dbox/2]])
    boxs = (int(center[0]-dbox/4), int(center[1]-dboy/4), int(center[0]+dbox/4), int(center[1]+dboy/4))
    if case == 0:
        outs= np.asarray(girada.crop(boxs), dtype="int32" )
    else:
        outs = boxs
    return outs
    
def IM(X,Y):
    p1,edges1=np.histogram(X,bins=range(DSIZE),density=True)
    p2,edges2=np.histogram(Y,bins=range(DSIZE),density=True)
    C=([])    
    C=np.append(C,X)
    C=np.append(C,Y)
    t=len(C)
    C=np.reshape(C,[int(t/2),2])
    H, edges =np.histogramdd(C, bins=(DSIZE, DSIZE),normed=True)
    mi=0    
    for i in range(DSIZE-1):
        for j in range(DSIZE-1):
            p12=p1[i]*p2[j]
            if H[i][j]>0 and p12>0: 
                mi=mi+H[i][j]*math.log((H[i][j]/p12),2)
    return mi

def arsaim(img,cor,ab): 
    sta =-CAM_ANGLE
    fin =CAM_ANGLE
    arr=([])
    k=0
    for h in range (sta,fin,PASOM):
        k=k+1
        imc = capcam(img,cor,ab+h)
        tam=imc.shape
        Y=np.reshape(imc,[tam[0]*tam[1]*tam[2],1])
        arr=np.append(arr,Y)
    t=len(arr)
    return np.reshape(arr,[int(t/k),k])
        
def BNP_IM(aimb,aimg,cor,ab):       
    sta =-CAM_ANGLE
    fin =CAM_ANGLE
    aim =([])
    agl =([])
    tam=aimb.shape
    k=0
    X=np.reshape(aimb,[tam[0]*tam[1]*tam[2],1])
    for h in range(sta,fin,PASOM):
       imc = aimg[:,k]
       k=k+1
       tem = IM(X,imc)
       aim = np.append(aim,tem)
       agl = np.append(agl,h)
    ind=aim==max(aim) # I've changed from min
    return agl[ind],aim
